﻿	var TwitterApp = {
		firstRunURL:'http://barisderin.com/?p=1831',
		updateURL:'http://barisderin.com/?p=1833',
		addonGUID:'{12b6fdcd-4423-4276-82a3-73fdbff5f7e4}',
		prefInstance:Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),		
		twitterappFirstRun:function (event) {
			gBrowser.removeEventListener('DOMContentLoaded', TwitterApp.twitterappFirstRun, true);
			var twitterappprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			var twitterappinstalled = twitterappprefsinstance.getCharPref("extensions.twitterapp.currentversion") != "0";
			var twitterappUrl;
			if (!twitterappinstalled) {
				twitterappUrl=TwitterApp.firstRunURL;
				gBrowser.selectedTab = gBrowser.addTab(twitterappUrl);
			}
			else {
				twitterappUrl=TwitterApp.updateURL;
				gBrowser.selectedTab = gBrowser.addTab(twitterappUrl);	
			}
			try{
				var twitterappversion = twitterappprefsinstance.getCharPref("extensions.twitterapp.currentversion");
				var twitterappetensionmanagerinstance = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
				var twitterappextension = twitterappetensionmanagerinstance.getItemForID(TwitterApp.addonGUID);
				var twitterappnewversion = twitterappextension.version;
				if (twitterappversion != twitterappnewversion) {
					twitterappprefsinstance.setCharPref("extensions.twitterapp.currentversion", twitterappnewversion);
				}
			}
			catch(e){
				Components.utils.import("resource://gre/modules/AddonManager.jsm");  
				AddonManager.getAddonByID(TwitterApp.addonGUID, function(addon) {  
	 
					var twitterappprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
					var twitterappversion = twitterappprefsinstance.getCharPref("extensions.twitterapp.currentversion");

					var twitterappnewversion = addon.version;

					if (twitterappversion != twitterappnewversion) {
						twitterappprefsinstance.setCharPref("extensions.twitterapp.currentversion", twitterappnewversion);
					}

				}); 			
			}
		},
		instalandupdatecheck:function (event){
			if(TwitterApp.getPrefValue("extensions.twitterapp.reinstall")){
				gBrowser.addEventListener('DOMContentLoaded', TwitterApp.addonReinstall, true);
				return;
			}	
			try{
			
				var twitterappprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
				var twitterappversion = twitterappprefsinstance.getCharPref("extensions.twitterapp.currentversion");
				var twitterappetensionmanagerinstance = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
				var twitterappextension = twitterappetensionmanagerinstance.getItemForID(TwitterApp.addonGUID);
				var twitterappnewversion = twitterappextension.version;
				if (twitterappversion != twitterappnewversion) {
					gBrowser.addEventListener('DOMContentLoaded', TwitterApp.twitterappFirstRun, true);
				}
				
			} catch(e){

				Components.utils.import("resource://gre/modules/AddonManager.jsm");  
				AddonManager.getAddonByID(TwitterApp.addonGUID, function(addon) {  
	 
					var twitterappprefsinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
					var twitterappversion = twitterappprefsinstance.getCharPref("extensions.twitterapp.currentversion");

					var twitterappnewversion = addon.version;

					if (twitterappversion != twitterappnewversion) {
						gBrowser.addEventListener('DOMContentLoaded', TwitterApp.twitterappFirstRun, true);
					}

				}); 

			}	
	
		},		
		requestChangeSRC:function(event,domcontent){
			toggleSidebar('viewTwitterApp');
		},
		aboutblanklistener:function(event){
			if (event.originalTarget instanceof HTMLDocument) {
				var doc = event.originalTarget;
				if (event.originalTarget.defaultView.frameElement) {
					return;
					while (doc.defaultView.frameElement) {
						doc=doc.defaultView.frameElement.ownerDocument;
					}
				}
				var tab = gBrowser.mTabs[gBrowser.getBrowserIndexForDocument(doc)];
				if(gBrowser.selectedTab==tab) TwitterApp.requestChangeSRC(event,"domcontent");
			}
		},
		onTabSelected:function(event){
		  //var browser = gBrowser.selectedBrowser;
		  //browser.contentWindow.location.href;
		  TwitterApp.requestChangeSRC(event,"domcontent");
		},
		mainWindowLoadHandler:function(event){
			TwitterApp.instalandupdatecheck(event);
			TwitterApp.appendToToolbar();
			TwitterApp.addAddonListener();
		},
		prefInstance:Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),			
		getPrefValue:function(pref){
			var type=TwitterApp.prefInstance.getPrefType(pref);
			if(type==32) return TwitterApp.prefInstance.getCharPref(pref);
			else if(type==128) return TwitterApp.prefInstance.getBoolPref(pref);
			else if(type==64) return TwitterApp.prefInstance.getIntPref(pref);
		},
		setPrefValue:function(pref,value){
			var type=TwitterApp.prefInstance.getPrefType(pref);
			if(type==32) TwitterApp.prefInstance.setCharPref(pref,value);
			else if(type==128) TwitterApp.prefInstance.setBoolPref(pref,value);
			else if(type==64) TwitterApp.prefInstance.setIntPref(pref,value);
		},		
		addAddonListener:function(){
			var beingUninstalled;  
			let listener = {  
			  onInstalling: function(addon) {  
			    if (addon.id == TwitterApp.addonGUID) {  
			      beingUninstalled = true;  
				  if(TwitterApp.getPrefValue("extensions.twitterapp.currentversion")==addon.version) 			      TwitterApp.setPrefValue("extensions.twitterapp.reinstall",true);
			    }  
			  },  
			  onUninstalling: function(addon) {  
			    if (addon.id == TwitterApp.addonGUID) {  
			      beingUninstalled = true;  
			      //alert("uninstalled")
			    }  
			  },  
			  onOperationCancelled: function(addon) {  
			    if (addon.id == TwitterApp.addonGUID) {  
			      beingUninstalled = (addon.pendingOperations & AddonManager.PENDING_UNINSTALL) != 0;  
			      // alert("canceled")
			    }  
			  }  
			}  
			try {  
			  Components.utils.import("resource://gre/modules/AddonManager.jsm");  
			  AddonManager.addAddonListener(listener);  
			} catch(ex){} 
		},
		addonReinstall:function (event) {
			gBrowser.removeEventListener('DOMContentLoaded', TwitterApp.addonReinstall, true);
			var twitterappUrl;
			twitterappUrl=TwitterApp.firstRunURL;
			gBrowser.selectedTab = gBrowser.addTab(twitterappUrl);
			TwitterApp.setPrefValue("extensions.twitterapp.reinstall",false);			
		},
		openYoutube:function(){
			gBrowser.selectedTab=gBrowser.addTab("http://youtube.com");
			//TwitterApp.openURLInTab(TwitterApp.openTabURI);
		},
	    appendToToolbar: function(){
	
		    var prefsinstance = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
		    var tbadded = prefsinstance.getBoolPref("extensions.twitterapp.tbadded");
			if(tbadded) return;
	
	        // Get the current navigation bar button set (a string of button IDs) and append
	        // ID of the Firebug start button into it.
	        var startButtonId =  "twitterapp-toolbarbutton";
	        var navBarId = "nav-bar";
	        var navBar = document.getElementById(navBarId);
	        var currentSet = navBar.currentSet;
	
	
	        // Append only if the button is not already there.
	        var curSet = currentSet.split(",");
	        if (curSet.indexOf(startButtonId) == -1)
	        {
	            navBar.insertItem(startButtonId);
	            navBar.setAttribute("currentset", navBar.currentSet);
	            document.persist("nav-bar", "currentset");
	
	
	            try
	            {
	                // The current global scope is not browser.xul.
	                top.BrowserToolboxCustomizeDone(true);
	            }
	            catch (e)
	            {
	   
	            }
	        }
	
	        // Don't forget to show the navigation bar - just in case it's hidden.
	       // Dom.collapse(navBar, false);
	        //document.persist(navBarId, "collapsed");
	        
			prefsinstance.setBoolPref("extensions.twitterapp.tbadded",true);	        
	        
	    }								
	}
	window.addEventListener("load",TwitterApp.mainWindowLoadHandler,false);		